SystemOrganization addCategory: #ConfigurationOfPhobos!

Object subclass: #ConfigurationOfPhobos
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPhobos'!

!ConfigurationOfPhobos commentStamp: 'PavelKrivanek 2/20/2014 21:54' prior: 0!
Phobos is a Smalltalk framework that helps to create platform independent desktop applications using XULRunner. It uses Mozilla XULRunner for rendering of GUI components. Phobos has component-based architecture inspired by Seaside.

You need:
- Pharo virtual machine
- Pharo image with preloaded Phobos
- Mozilla XULRunner (https://developer.mozilla.org/en-US/docs/Mozilla/Projects/XULRunner)
- small JavaScript application and template files (git clone https://code.google.com/p/phobos-framework/)

OR 

You can download prebuild bundles from:
https://ci.inria.fr/pharo-contribution/view/Phobos/


| app |
app := PhobosDemo new.
app start.

app stop.
PhobosApplication allSubInstances do: #stop!

!ConfigurationOfPhobos class methodsFor: 'development support' stamp: 'PavelKrivanek 10/31/2012 11:59'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPhobos class methodsFor: 'private' stamp: 'PavelKrivanek 10/31/2012 11:59'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPhobos class methodsFor: 'catalog' stamp: 'PavelKrivanek 2/20/2014 21:38'!
catalogChangeLog
	"Returns a paragraph describing the most important changes in the configuration class."
	^ '- 1.1.0 - 20 February 2014- update for Pharo 3.0'! !

!ConfigurationOfPhobos class methodsFor: 'catalog' stamp: 'PavelKrivanek 2/20/2014 21:38'!
catalogContactInfo
	"Returns a paragraph describing contact information such as email, mailing lists and website."
	^ 'pavel.krivanek@gmail.com'! !

!ConfigurationOfPhobos class methodsFor: 'catalog' stamp: 'PavelKrivanek 2/20/2014 21:40'!
catalogDescription
	"Returns a paragraph describing the project"
	^ 'Phobos is a Smalltalk framework that helps to create platform independent desktop applications using XULRunner. It uses Mozilla XULRunner for rendering of GUI components. Phobos has component-based architecture inspired by Seaside.'! !

!ConfigurationOfPhobos class methodsFor: 'catalog' stamp: 'PavelKrivanek 2/20/2014 21:42'!
catalogKeyClassesAndExample
	"Returns a paragraph or more describing the key classes of your project. You can use Pillar/Pier syntax to layout out the text i.e., ==Code== and - for bullet."
	^ '==PhobosApplication== - base class for you applications'! !

!ConfigurationOfPhobos class methodsFor: 'catalog' stamp: 'PavelKrivanek 2/20/2014 21:43'!
catalogKeywords
	"Returns an array of symbols"
	^ #(gui xul websockets) ! !

!ConfigurationOfPhobos class methodsFor: 'private' stamp: 'PavelKrivanek 10/31/2012 11:59'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPhobos class methodsFor: 'private' stamp: 'PavelKrivanek 10/31/2012 11:59'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPhobos class methodsFor: 'metacello tool support' stamp: 'PavelKrivanek 10/31/2012 11:59'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPhobos class methodsFor: 'loading' stamp: 'PavelKrivanek 10/31/2012 11:59'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPhobos class methodsFor: 'loading' stamp: 'PavelKrivanek 10/31/2012 11:59'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPhobos class methodsFor: 'loading' stamp: 'PavelKrivanek 10/31/2012 11:59'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPhobos class methodsFor: 'accessing' stamp: 'PavelKrivanek 10/31/2012 11:59'!
project

	^self new project! !

!ConfigurationOfPhobos class methodsFor: 'development support' stamp: 'PavelKrivanek 10/31/2012 11:59'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPhobos methodsFor: 'postload' stamp: 'PavelKrivanek 2/24/2014 14:19'!
appName

	^ 'PhobosDemo'.
! !

!ConfigurationOfPhobos methodsFor: 'baselines' stamp: 'PavelKrivanek 2/20/2014 20:21'!
baseline1x0x0: spec
  
	<version: '1.0.0-baseline'>
	
	| seasideRepository |
	
	seasideRepository := 'http://www.squeaksource.com/Seaside30'.

	spec for: #pharo do: [
		spec 
			blessing: #baseline;
			repository: 'http://smalltalkhub.com/mc/PavelKrivanek/Phobos/main'.
			
		spec
			project: 'ZincHTTPComponents' with: [
				spec repository: 'http://mc.stfx.eu/ZincHTTPComponents'.
				spec className: 'ConfigurationOfZincHTTPComponents'.
				spec file: 'ConfigurationOfZincHTTPComponents'.
				spec loads: #('Zinc-HTTP' 'Zinc-FileSystem' 'Zinc-Tests' 'Zinc-WebSocket-Core')].
					
		spec project: 'Grease' with: [
			spec repository: seasideRepository.
			spec className: 'ConfigurationOfGrease'.
			spec file: 'ConfigurationOfGrease'.
			spec loads: #('Grease-Core' 'Grease-Pharo-Core' )].

		spec project: 'Seaside-Continuation' with: [
			spec repository: seasideRepository.
			spec className: 'ConfigurationOfSeaside30'.
			spec file: 'ConfigurationOfSeaside30'.
			spec loads: #('Seaside-Pharo-Continuation' )].

		spec package: 'JSON' with: [
			spec repository: 'http://smalltalkhub.com/mc/PharoExtras/SCouchDBViewServer/main'].
			
		spec package: 'Phobos-Core' with: [spec requires: #('ZincHTTPComponents' 'Grease' 'Seaside-Continuation' 'JSON') ].
		spec package: 'Phobos-XUL' with: [spec requires: #('Phobos-Core') ].
		spec package: 'Phobos-HTML' with: [spec requires: #('Phobos-Core') ].
		spec package: 'Phobos-Demo' with: [spec requires: #('Phobos-XUL' 'Phobos-HTML') ].
			
		spec group: 'default' with: #('Phobos-Core' 'Phobos-XUL' 'Phobos-HTML' 'Phobos-Demo').
		spec group: 'demo' with: #('Phobos-Core' 'Phobos-XUL' 'Phobos-HTML' 'Phobos-Demo').
		spec group: 'core' with: #('Phobos-Core' 'Phobos-XUL' 'Phobos-HTML').
	].
	
	spec for: #squeakCommon do: [
		].
   
      
        
! !

!ConfigurationOfPhobos methodsFor: 'baselines' stamp: 'PavelKrivanek 2/24/2014 14:07'!
baseline1x1x0: spec
  
	<version: '1.1.0-baseline'>
	
	spec for: #'pharo3.0.x' do: [
		spec 
			blessing: #baseline;
			repository: 'http://smalltalkhub.com/mc/PavelKrivanek/Phobos/main'.
			
		spec project: 'ZincHTTPComponents' with: [
			spec repository: 'http://mc.stfx.eu/ZincHTTPComponents'.
			spec className: 'ConfigurationOfZincHTTPComponents'.
			spec file: 'ConfigurationOfZincHTTPComponents'.
			spec loads: #('Zinc-WebSocket-Core')].
					
		spec project: 'OSProcess' with: [ 
			spec repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main/'.
			spec className: 'ConfigurationOfOSProcess'.
			spec loads: #('Core with Output') ].		
					
		spec package: 'JSON' with: [
			spec repository: 'http://smalltalkhub.com/mc/PharoExtras/SCouchDBViewServer/main'].
			
		spec package: 'Phobos-Core' with: [spec requires: #('ZincHTTPComponents' 'JSON') ].
		spec package: 'Phobos-XUL' with: [spec requires: #('Phobos-Core') ].
		spec package: 'Phobos-HTML' with: [spec requires: #('Phobos-Core') ].
		spec package: 'Phobos-Demo' with: [spec requires: #('Phobos-XUL' 'Phobos-HTML' 'OSProcess') ].
			
		spec group: 'default' with: #('Phobos-Core' 'Phobos-XUL' 'Phobos-HTML' 'Phobos-Demo').
		spec group: 'demo' with: #('Phobos-Core' 'Phobos-XUL' 'Phobos-HTML' 'Phobos-Demo').
		spec group: 'core' with: #('Phobos-Core' 'Phobos-XUL' 'Phobos-HTML').
		
		spec postLoadDoIt: #'postload1x1x0:package:'.

	].
      
        
! !

!ConfigurationOfPhobos methodsFor: 'accessing' stamp: 'PavelKrivanek 10/31/2012 11:59'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfPhobos methodsFor: 'baselines' stamp: 'PavelKrivanek 2/20/2014 20:53'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1.0'.
! !

!ConfigurationOfPhobos methodsFor: 'postload' stamp: 'PavelKrivanek 2/24/2014 14:18'!
gitRepository 

	^ 'git clone https://code.google.com/p/phobos-framework/' 
	! !

!ConfigurationOfPhobos methodsFor: 'postload' stamp: 'PavelKrivanek 2/25/2014 10:00'!
postload1x1x0: loader package: packageSpec

	Smalltalk isHeadless ifFalse: [ 
		(UIManager confirm: 'Do you want to start PhobosDemo application?')
			ifTrue: [
					Smalltalk os isUnix ifTrue: [ self postloadUnix ].
					Smalltalk os isWindows ifTrue: [ self postloadWindows ].
					Smalltalk os isMacOSX ifTrue: [ self postloadMacOS ] ] ].

! !

!ConfigurationOfPhobos methodsFor: 'postload' stamp: 'PavelKrivanek 2/25/2014 09:58'!
postloadMacOS

	self error: 'currently not ready for this platform'! !

!ConfigurationOfPhobos methodsFor: 'postload' stamp: 'PavelKrivanek 2/24/2014 14:27'!
postloadUnix

	| c fs prefs exec app  |
	 
	c := PipeableOSProcess command: self gitRepository.
	(c output; succeeded)
		ifFalse: [ self error: 'Git error: ', c errorPipelineContents printString].
		
	fs := FileSystem disk.

	fs ensureCreateDirectory: fs workingDirectory / self appName.
	(fs workingDirectory / 'phobos-framework' / 'template-linux' / 'PhobosDemo' ) copyAllTo: (fs workingDirectory / self appName).
	fs ensureCreateDirectory: fs workingDirectory / self appName / 'chrome' / 'content'.
	(fs workingDirectory / 'phobos-framework' / 'content' ) copyAllTo: (fs workingDirectory / self appName / 'chrome' / 'content').

	prefs :=  (fs workingDirectory / self appName / 'defaults' / 'preferences' / 'prefs.js').

	prefs writeStream nextPutAll: (prefs readStream contents copyReplaceAll: 'chrome://myapp/content/splash/splash.xul' with: 'chrome://myapp/content/templates/main.xul').

	app := PhobosDemo new.
	app start.

	exec :=  './', self appName, '/', self appName, '.sh'.  
	c := PipeableOSProcess command: 'chmod +x ', exec. 
	(c output; succeeded)
		ifFalse: [ self error: 'chmod error: ', c errorPipelineContents printString].

	c := OSProcess command:  exec.! !

!ConfigurationOfPhobos methodsFor: 'postload' stamp: 'PavelKrivanek 2/25/2014 09:50'!
postloadWindows

	| c fs prefs exec app contents |
	 
	fs := FileSystem disk.
	
	contents := ZnClient new
		beOneShot;
		url: 'https://ci.inria.fr/pharo-contribution/view/Phobos/job/Phobos-git/lastSuccessfulBuild/artifact/template-win.zip';
		get.
	
	ZipArchive new 
		readFrom: contents readStream;
		extractAllTo: FileSystem disk workingDirectory.
		
	UIManager default informUserDuring: [ :bar |
 		 [ ZnClient new
      			url: 'http://ftp.mozilla.org/pub/mozilla.org/xulrunner/releases/27.0/runtimes/xulrunner-27.0.en-US.win32.zip';
      			signalProgress: true;
      			downloadTo: 'xulrunner.zip' ]
        		on: HTTPProgress
        		do: [ :progress |
                		bar label: progress printString.
                		progress isEmpty ifFalse: [ bar current: progress percentage ].
                		progress resume ] ].
	ZipArchive new 
		readFrom:  FileSystem disk workingDirectory / 'xulrunner.zip';
		extractAllTo: FileSystem disk workingDirectory.

	fs ensureCreateDirectory: fs workingDirectory / self appName.
	
	(fs workingDirectory / 'template-win' / 'PhobosDemo' ) copyAllTo: (fs workingDirectory / self appName).
	
	contents := ZnClient new
		beOneShot;
		url: 'https://ci.inria.fr/pharo-contribution/view/Phobos/job/Phobos-git/lastSuccessfulBuild/artifact/content.zip';
		get.
	
	ZipArchive new 
		readFrom: contents readStream;
		extractAllTo: (fs workingDirectory / self appName / 'chrome').
	
	prefs :=  (fs workingDirectory / self appName / 'defaults' / 'preferences' / 'prefs.js').

	prefs writeStream nextPutAll: (prefs readStream contents copyReplaceAll: 'chrome://myapp/content/splash/splash.xul' with: 'chrome://myapp/content/templates/main.xul').

	ZipArchive new 
		readFrom:  FileSystem disk workingDirectory / 'xulrunner.zip';
		extractAllTo: FileSystem disk workingDirectory /  self appName .
		
	(FileSystem disk workingDirectory /  self appName / 'xulrunner' / 'xulrunner-stub.exe') copyTo: (FileSystem disk workingDirectory /  self appName / 'PhobosDemo.exe').
	
	app := PhobosDemo new.
	app start.

	exec :=  './', self appName, '/PhobosDemo.exe'.
	c := OSProcess command:  exec.! !

!ConfigurationOfPhobos methodsFor: 'postload' stamp: 'PavelKrivanek 2/24/2014 14:12'!
precheck

	| c | 
	
	"check git"
	c := PipeableOSProcess command: 'git --version' .
	(c output; succeeded) ifFalse: [ self error: 'git not installed.' ].

	"check xulrunner"
	c := PipeableOSProcess command: 'xulrunner -v' .
	(c output; succeeded) ifFalse: [ self error: 'git not installed.' ].
! !

!ConfigurationOfPhobos methodsFor: 'accessing' stamp: 'PavelKrivanek 10/31/2012 11:59'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPhobos methodsFor: 'baselines' stamp: 'PavelKrivanek 2/20/2014 21:03'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.1.0'.
! !

!ConfigurationOfPhobos methodsFor: 'baselines' stamp: 'PavelKrivanek 2/20/2014 20:25'!
version1x0x0: spec
	<version: '1.0.0' imports: #('1.0.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec package: 'Phobos-Core' with: 'Phobos-Core-PavelKrivanek.25'. 
		spec package: 'Phobos-XUL' with: 'Phobos-XUL-PavelKrivanek.12'. 
		spec package: 'Phobos-HTML' with: 'Phobos-HTML-PavelKrivanek.2'. 
		spec package: 'Phobos-Demo' with: 'Phobos-Demo-PavelKrivanek.27'. 
		spec package: 'JSON' with: 'JSON-DieterRoth.Stasenko.38'.
		spec project: 'ZincHTTPComponents' with:  '1.9.3'.
		spec project: 'Grease' with: #stable.
		spec project: 'Seaside-Continuation' with: #stable.
	].
! !

!ConfigurationOfPhobos methodsFor: 'baselines' stamp: 'PavelKrivanek 2/20/2014 21:32'!
version1x1x0: spec
	<version: '1.1.0' imports: #('1.1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec package: 'Phobos-Core' with: 'Phobos-Core-PavelKrivanek.27'. 
		spec package: 'Phobos-XUL' with: 'Phobos-XUL-PavelKrivanek.12'. 
		spec package: 'Phobos-HTML' with: 'Phobos-HTML-PavelKrivanek.2'. 
		spec package: 'Phobos-Demo' with: 'Phobos-Demo-PavelKrivanek.27'. 
		spec package: 'JSON' with: 'JSON-JesusMari.Stasenko.50'.
		spec project: 'ZincHTTPComponents' with:  '1.9.3'.
	].
! !
